package org.processmining.models.queueminer.context;

import java.util.ArrayList;

public class ConcatenatedContext {
	ArrayList<ContextItem> items;
	
	public ConcatenatedContext(ArrayList<ContextItem> items){
		this.items = items;
	}
	
	/**
	 * Returns a concatenated string representation of all context items that are present at given time
	 * @param time
	 * @pre the items are sorted
	 * @return
	 */
	public String getContextAtTime(long time){
		//maybe replace with binary search
		//edge cases
		if(time < items.get(0).time){
			return "null";//concatStrings(items.get(0).getIdentifiers(),";");
		}
		if(time > items.get(items.size()-1).time){
			return concatStrings(items.get(items.size()-1).getIdentifiers(),";");
		}
		//in between 2 times
		for(int i = 0; i < items.size()-1;i++){
			long start = items.get(i).time;
			long end = items.get(i+1).time;
			if(time >= start && time <= end){
				return concatStrings(items.get(i).getIdentifiers(),";");
			}
		}
		//this shouldnt happen
		System.err.println("This shouldn't have happened! One of the cases should always be true");
		return null;
	}
	
	/**
	 * Returns context identifier string for given time
	 * @param strings
	 * @param seperator
	 * @return
	 */
	public String concatStrings(ArrayList<String> strings, String seperator){
		String result = "";
		boolean first = true;
		for(String s:strings){
			if(!first){
				result+=seperator;
			}
			else{
				first= false;
			}
			result+=s;
		}
		return result;
	}
}
