package org.processmining.models.queueminer.logcontext;

import java.net.URI;
import java.util.Collection;

import org.deckfour.xes.extension.XExtension;
import org.deckfour.xes.extension.XExtensionManager;
import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.extension.std.XTimeExtension;
import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryRegistry;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.deckfour.xes.model.impl.XAttributeLiteralImpl;
import org.processmining.models.queueminer.context.ConcatenatedContext;

public class LogEnricher {
	
	public static XLog enrichLog(ConcatenatedContext tc, XLog log){
		XTimeExtension xte = XTimeExtension.instance();
		XExtensionManager xem = XExtensionManager.instance();
		URI contextUri = URI.create("http://www.zerodivision.nl/XES/context.xesext");
		XExtension xce = xem.getByUri(contextUri);
		Collection<XAttribute> attributes = xce.getEventAttributes();
		
		XFactory xlogf = XFactoryRegistry.instance().currentDefault();
        XLog xlog = xlogf.createLog();
        XConceptExtension xcone = XConceptExtension.instance();
        
		for(XTrace tr:log){
			XTrace xtr = xlogf.createTrace();
			xcone.assignName(xtr, tr.getAttributes().get("concept:name").toString());
			for(XEvent ev:tr){
				//get context key
				XAttribute contattr = attributes.iterator().next();
				String key = contattr.getKey();
				//get context value
				long time = xte.extractTimestamp(ev).getTime();
				String context = tc.getContextAtTime(time);
				XAttribute value = new XAttributeLiteralImpl(key, context);
				//add new info to attribute map of event
				XAttributeMap evattr = ev.getAttributes();
				evattr.put(key, value);
				ev.setAttributes(evattr);
				
				xtr.add(ev);
			}
			
			xlog.add(xtr);
		}

		return xlog;
	}
}
