package org.processmining.models.queueminer.patternvisualizer;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

public class PLTButtons extends JPanel implements ActionListener{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	JButton newTree;
	JTextField daysConsideredField;
	JTextField nodeWidth;
	JTextField nodeHeight;
	JTextField layerSpacing;
	JButton updateTree;
	PrimeLogTreeView vis;
	private final String[] metrics = new String[]{"Distribution size","Distribution mean","Distribution variance"};
	JComboBox<String> metricsBox;
	JComboBox<String> zoomIn;
	JTextField customRootField;
	JCheckBox dummies;
	
	public PLTButtons(PrimeLogTreeView vis){
		Dimension oneLiner = new Dimension(Integer.MAX_VALUE,20);
		
		newTree = new JButton("Begin new tree");
		newTree.setActionCommand("newVis");
		newTree.addActionListener(this);
		
		daysConsideredField = new JTextField(20);
		daysConsideredField.setMaximumSize(oneLiner);
		
		nodeWidth = new JTextField(20);
		nodeWidth.setMaximumSize(oneLiner);
		
		nodeHeight = new JTextField(20);
		nodeHeight.setMaximumSize(oneLiner);
		
		layerSpacing = new JTextField(20);
		layerSpacing.setMaximumSize(oneLiner);
		
		updateTree = new JButton("Update tree");
		updateTree.setActionCommand("updateVis");
		updateTree.addActionListener(this);
		
		metricsBox = new JComboBox<>(metrics);
		metricsBox.setMaximumSize(oneLiner);
		
		zoomIn = new JComboBox<String>();
		zoomIn.addItem("None");
		zoomIn.addItem("Single node");
		zoomIn.addItem("Node set");
		zoomIn.setMaximumSize(oneLiner);
		
		customRootField = new JTextField("1");
		customRootField.setMaximumSize(oneLiner);
		
		dummies = new JCheckBox();
		dummies.setSelected(true);
		
		this.vis = vis;
		this.setLayout(new BoxLayout(this,BoxLayout.PAGE_AXIS));
		this.setMaximumSize(new Dimension(100,Integer.MAX_VALUE));
	}
	
	public PLTButtons getButtonPanel(){
		Dimension oneLiner = new Dimension(Integer.MAX_VALUE,20);
		
		this.add(newTree);
		JLabel daysConsideredFieldLabel = new JLabel("Length of biggest time unit (days):");
		this.add(daysConsideredFieldLabel);
		this.add(daysConsideredField);
		
		this.add(updateTree);
		
		JLabel metricLabel = new JLabel("Metric");
		this.add(metricLabel);
		this.add(metricsBox);
		
		JLabel nodeWidthLabel = new JLabel("Node width (px)");
		this.add(nodeWidthLabel);
		this.add(nodeWidth);
		
		JLabel nodeHeightLabel = new JLabel("Node height (px)");
		this.add(nodeHeightLabel);
		this.add(nodeHeight);
		
		JLabel layerSpaceLabel = new JLabel("Layer spacing (px)");
		this.add(layerSpaceLabel);
		this.add(layerSpacing);
		
		JLabel zoomLabel = new JLabel("Zoom modus:");
		this.add(zoomLabel);
		this.add(zoomIn);
		this.add(customRootField);
		
		//JLabel dummyLabel = new JLabel("Remove empty distributions");
		//this.add(dummyLabel);
		//this.add(dummies);
		JSeparator legStart = new JSeparator(SwingConstants.HORIZONTAL);
		legStart.setMaximumSize(oneLiner);
		this.add(legStart);
		
		JLabel legendLabel = new JLabel("Legend:");
		this.add(legendLabel);
		this.add(new LegendPanel());
		
		return this;
	}

	public void actionPerformed(ActionEvent e) {
		if ("updateVis".equals(e.getActionCommand())) {
			int nodeW = 150;
			int nodeH = 100;
			int layerPx = 20;
			String metric = metrics[0];
			try{
				nodeW = Integer.parseInt(nodeWidth.getText());
				nodeH = Integer.parseInt(nodeHeight.getText());
				layerPx = Integer.parseInt(layerSpacing.getText());
			}
			catch(Exception ex){};
			try{
				metric = metricsBox.getSelectedItem().toString();
			}
			catch(Exception ex){};
			
			String zoomOption = zoomIn.getSelectedItem().toString();
			int rootNr = 1;
			ArrayList<Integer> zoomNodes = new ArrayList<>();
			if(zoomOption.equals("Single node")){
				try{
					rootNr = Integer.parseInt(customRootField.getText()); 
				}
				catch(Exception exc){}
			}
			else if(zoomOption.equals("Node set")){
				String[] splitNrs = customRootField.getText().split(",");
				for(String nr:splitNrs){
					nr = nr.trim();
					try{
					int add = Integer.parseInt(nr);
					zoomNodes.add(add);
					}
					catch(Exception exc){}
				}
			}

			boolean drawdum = !dummies.isSelected();
			vis.setRootParameters(zoomOption,rootNr,zoomNodes);
			vis.updateParameters(layerPx, nodeW,nodeH,metric,drawdum);
			vis.updateMax();
			vis.repaint();
		}
		else if("newVis".equals(e.getActionCommand())) {
			int daysConsidered = 7;
			try{
				 daysConsidered = Integer.parseInt(daysConsideredField.getText());
			}
			catch(Exception exc){}
			//System.out.println("new tree with "+daysConsidered+" days considered");
			vis.newTree(daysConsidered);
		}
		
	}
}
