package org.processmining.models.queueminer.patternvisualizer;

import java.util.ArrayList;


public class PrimeLogNode implements Comparable<PrimeLogNode>{
	int k;
	ArrayList<PrimeLogNode> children;
	ArrayList<DistributionInfo> sublogs;
	
	public PrimeLogNode(int k, ArrayList<DistributionInfo> sublogs){
		this.k = k;
		this.sublogs = sublogs;
		//System.out.println("tree with nr: "+k+" has "+sublogs.size()+" sublogs.");
		children = new ArrayList<>();
	}
	
	public int getK(){
		return k;
	}
	
	public ArrayList<DistributionInfo> getSubLogs(){
		return sublogs;
	}
	
	public ArrayList<PrimeLogNode> getChildren(){
		return children;
	}
	
	public void addChild(PrimeLogNode pln){
		children.add(pln);
	}

	public int compareTo(PrimeLogNode pln) {
		return Integer.compare(k, pln.k);
	}
}
