package org.processmining.models.queueminer.queuepredictor;

import java.util.ArrayList;
import java.util.Date;

import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.models.queueminer.utils.ArrivingEvent;

public class PredictionDataVisualizer {
	@Plugin(name = "Queue prediction results", returnLabels = { "Visualization of queue prediction data" }, returnTypes = { JComponent.class }, parameterLabels = {"PredictionDataContainer"}, userAccessible = false)
	@Visualizer
	public JComponent viewQueuePredictions(PluginContext context, PredictionDataContainer pred){
		JPanel panel = new JPanel();
		String[] columnNames = {"Id","Activity type","Arrival time","Context","Predicted exit time"};
		ArrayList<ArrivingEvent> aes = pred.getPredictionData();
		String[][] tableData = new String[aes.size()][5];
		for(int i = 0; i < aes.size(); i++){
			tableData[i][0] = aes.get(i).getID();
			tableData[i][1] = aes.get(i).eventType;
			tableData[i][2] = formatTime(aes.get(i).arrivalTime);
			tableData[i][3] = aes.get(i).context;
			tableData[i][4] = formatTime(aes.get(i).getPredictedTime());
		}
		
		//do table rendering
		final JTable table = new JTable(tableData,columnNames);
		JScrollPane scrollpane = new JScrollPane(table);
		panel.setLayout(new BoxLayout(panel,BoxLayout.PAGE_AXIS));
		panel.add(scrollpane);
		return panel;
	}
	
	public static String formatTime(long time){
		Date d = new Date(time);
		return d.toString();
	}
}
