package org.processmining.models.queueminer.sojournpredictor;

import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.models.queueminer.queuepredictor.PredictionDataVisualizer;
import org.processmining.models.queueminer.utils.ArrivingTrace;

public class SojPredictionDataVisualizer {
	@Plugin(name = "Queue prediction results", returnLabels = { "Visualization of queue sojourn prediction data" }, returnTypes = { JComponent.class }, parameterLabels = {"SojPredictionDataContainer"}, userAccessible = false)
	@Visualizer
	public JComponent viewQueuePredictions(PluginContext context, SojPredictionDataContainer pred){
		JPanel panel = new JPanel();
		String[] columnNames = {"Trace ID","ID","Activity type","Arrival time","Context","Predicted exit time"};
		ArrayList<ArrivingTrace> aes = pred.getPredictionData();
		String[][] tableData = new String[aes.size()][6];
		for(int i = 0; i < aes.size(); i++){
			tableData[i][0] = aes.get(i).getTraceID();
			tableData[i][1] = aes.get(i).getEventID();
			tableData[i][2] = aes.get(i).eventType;
			tableData[i][3] = PredictionDataVisualizer.formatTime(aes.get(i).arrivalTime);
			tableData[i][4] = aes.get(i).context;
			tableData[i][5] = PredictionDataVisualizer.formatTime(aes.get(i).getPredictedTime());
		}
		
		//do table rendering
		final JTable table = new JTable(tableData,columnNames);
		JScrollPane scrollpane = new JScrollPane(table);
		panel.setLayout(new BoxLayout(panel,BoxLayout.PAGE_AXIS));
		panel.add(scrollpane);
		return panel;
	}
}	
