package org.processmining.models.queueminer.startupremover;

import java.util.ArrayList;
import java.util.Date;

import org.deckfour.xes.extension.std.XTimeExtension;
import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryRegistry;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.models.queueminer.distribution.DistributionFilter;
import org.processmining.models.queueminer.utils.TimeActivity;
import org.processmining.models.queueminer.utils.TimeActivityUtilities;

public class StartUpRemover {
	
	/**
	 * remove all events from log that do not start between start and end
	 * @param log
	 * @param start
	 * @param end
	 * @return
	 */
	public static XLog removePeriod(XLog log, long start, long end){
		ArrayList<TimeActivity> tlog = TimeActivityUtilities.findTimeActivities(log);
		long minTime = DistributionFilter.logMinTime(tlog);
		long minPlusDayTimeStart = minTime + start * 24 * 3600 * 1000;
		long minPlusDayTimeEnd = minTime + end * 24 * 3600 * 1000;
		
		XFactory xlogf = XFactoryRegistry.instance().currentDefault();
		XTimeExtension xte = XTimeExtension.instance();
        XLog newLog = xlogf.createLog();
        newLog.setAttributes(log.getAttributes());
		for(XTrace trace: log){
			XTrace newTr = xlogf.createTrace();
			newTr.setAttributes(trace.getAttributes());
			for(XEvent event:trace){
				Date date = xte.extractTimestamp(event);
				long time = date.getTime();
				if(time >= minPlusDayTimeStart && time <= minPlusDayTimeEnd){
					newTr.add(event);
				}
			}
			if(newTr.size() > 0){
				newLog.add(newTr);
			}
		}
		
		return newLog;
	}
}
