package org.processmining.models.queueminer.utils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.processmining.models.queueminer.distribution.Point;

public class Queue {
	List<String> resources;
	List<String> activities;
	long arrivalRate;//poisson arrival rate 
	long meanWork; //mean working time for tasks
	long stdWork;//std dev time for tasks
	HashMap<String,HashMap<Integer,ArrayList<Point>>> queueServiceRate;
	HashMap<String,HashMap<Integer,Integer>> queueArrivalRate;
	long subTime;
	
	/**
	 * 
	 * @param resources
	 * @param activities
	 */
	public Queue(List<String> resources, List<String> activities){
		this.resources = resources;
		this.activities = activities;
	}
	
	public long getSubTime(){
		return subTime;
	}
	
	public HashMap<String,HashMap<Integer,Integer>> getArrivalRate(){
		return queueArrivalRate;
	}
	
	public HashMap<String,HashMap<Integer,ArrayList<Point>>> getServiceRate(){
		return queueServiceRate;
	}
	
	public void setQueueServiceRate(HashMap<String,HashMap<Integer,ArrayList<Point>>> queuesizeServiceRate){
		this.queueServiceRate = queuesizeServiceRate;
	}
	
	public void setQueueArrivalRate(HashMap<String,HashMap<Integer,Integer>> queueArrivalRate, long subTime){
		this.queueArrivalRate = queueArrivalRate;
		this.subTime = subTime;
	}
	
	public void addResource(String res){
		resources.add(res);
	}
	
	public void addActivity(String act){
		activities.add(act);
	}
	
	public List<String> getResources(){
		return resources;
	}
	
	public List<String> getActivities(){
		return activities;
	}
	
	@Override
	public String toString(){
		return queueServiceRate.toString()+" "+queueArrivalRate.toString();
	}
	
	public String resActString(){
		return "res: "+resources.toString()+", act:"+activities.toString();
	}
}
