package org.processmining.models.queueminer.utils;

import java.util.ArrayList;
import java.util.List;

import org.deckfour.xes.model.XEvent;

public class TimeActivity implements Comparable<TimeActivity>{
	public long start;
	public long end;
	public String type;
	public int queueSize;
	public XEvent original;
	
	public TimeActivity(long start, long end, String type, XEvent original){
		this.start = start;
		this.end = end;
		this.type = type;
		this.original = original;
	}

	public int compareTo(TimeActivity arg0) {
		if(start < arg0.start){
			return -1;
		}
		else if(start == arg0.start){
			return 0;
		}
		else{
			return 1;
		}
	}
	
	/**
	 * return max(0,nrResources - # acts that overlap start of ta)
	 * @param log
	 * @param ta
	 * @param nrResources
	 * @return
	 */
	public int queueLengthForAct(ArrayList<TimeActivity> tlLog, int nrResources, List<String> activities){
		//find all activities that overlap the start of ta
		int nrOverlap = 0;
		for(TimeActivity ta2:tlLog){
			if(activities.contains(ta2.type)){
				if(ta2.start <= this.start && ta2.end >= this.start){
					nrOverlap++;
				}
			}
		}
		int queueSize = nrOverlap - nrResources;
		return Math.max(0, queueSize);
	}
}
