package org.processmining.models.queueminer.utils;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;

public class TimeUtilities {
	public static long findFirstWeekStart(ArrayList<TimeActivity> tlog){
		Collections.sort(tlog);
		long time = tlog.get(0).start;
		
		Date d = new Date(time);
		Calendar cal = Calendar.getInstance();
	    cal.setTime(d);

	    // "calculate" the start date of the week
	    Calendar first = (Calendar) cal.clone();
	    first.set(Calendar.DAY_OF_WEEK, 
	              first.getFirstDayOfWeek());
	    
	    return first.getTime().getTime();
	}
	
	public static long findFirstDayStart(ArrayList<TimeActivity> tlog){
		Collections.sort(tlog);
		long time = tlog.get(0).start;
		
		Date d = new Date(time);
		Calendar cal = Calendar.getInstance();
	    cal.setTime(d);
	    
	    Calendar first = (Calendar) cal.clone();
	    first.set(Calendar.HOUR_OF_DAY,0);
	    first.set(Calendar.MINUTE, 0);
	    first.set(Calendar.SECOND, 0);
	    first.set(Calendar.MILLISECOND, 0);
	    
	    return first.getTime().getTime();
	    
	}
	
	public static long findLastDayStart(ArrayList<TimeActivity> tlog){
		Collections.sort(tlog);
		long time = tlog.get(tlog.size()-1).start;
		
		Date d = new Date(time);
		Calendar cal = Calendar.getInstance();
	    cal.setTime(d);
	    
	    Calendar first = (Calendar) cal.clone();
	    first.set(Calendar.HOUR_OF_DAY,0);
	    first.set(Calendar.MINUTE, 0);
	    first.set(Calendar.SECOND, 0);
	    first.set(Calendar.MILLISECOND, 0);
	    
	    return first.getTime().getTime();
	}
	
	/*public static void main(String[] args){
		TimeActivity test = new TimeActivity(10000000000l,10010000000l,"bla",null);
		ArrayList<TimeActivity> newList = new ArrayList<>();
		newList.add(test);
		System.out.println(findFirstWeekStart(newList));
	}*/
}
