package org.processmining.plugins.queueminer.bottleneckfinder;

import java.util.ArrayList;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.queueminer.bottleneckfinder.BottleneckData;
import org.processmining.models.queueminer.bottleneckfinder.BottleneckFinder;
import org.processmining.models.queueminer.bottleneckfinder.RankedQueue;
import org.processmining.models.queueminer.queueclusterer.QueueClustering;

@Plugin(name = "Find bottlenecks in queue clustering", returnLabels = { "Bottleneck data" }, returnTypes = { BottleneckData.class }, parameterLabels = {
		"Queue clustering with rates", "Parameters" }, userAccessible = true)
public class BottleNeckFinderPlugin {
	
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "L.P.J. de Smet", email = "l.p.j.d.smet@student.tue.nl")
	@PluginVariant(variantLabel = "Find bottleneck data given queue clustering", requiredParameterLabels = { 0})
	public  BottleneckData findErrorOfPrediction(UIPluginContext context,QueueClustering input){
		ArrayList<RankedQueue> rqs = BottleneckFinder.scoreQueueWeekly(input);
		return new BottleneckData(rqs);
	}
}
