package org.processmining.plugins.queueminer.bottleneckfinder;

import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.models.queueminer.bottleneckfinder.BottleneckData;
import org.processmining.models.queueminer.bottleneckfinder.RankedQueue;

public class BottleneckDataVisualizerPlugin {
	@Plugin(name = "Bottleneck data visualizer", returnLabels = { "Bottleneck data visualizer" }, returnTypes = { JComponent.class }, parameterLabels = {"BottleneckData"}, userAccessible = false)
	@Visualizer
	public JComponent viewData(PluginContext context, BottleneckData bd){
		JPanel panel = new JPanel();
		//compile table data
		ArrayList<RankedQueue> rqs = bd.getRankedQueues();
		String[] columnNames = {"Rank","Score","Activities","Resources"};
		String[][] tableData = new String[rqs.size()][4];
		for(int i = 0; i < rqs.size(); i++){
			tableData[i][0] = i+"";
			tableData[i][1] = rqs.get(i).getScore()+"";
			tableData[i][2] = rqs.get(i).getQueue().getActivities().toString();
			tableData[i][3] = rqs.get(i).getQueue().getResources().toString();
		}
		
		//do table rendering
		final JTable table = new JTable(tableData,columnNames);
		JScrollPane scrollpane = new JScrollPane(table);
		panel.setLayout(new BoxLayout(panel,BoxLayout.PAGE_AXIS));
		panel.add(scrollpane);
		return panel;
	}
}
