package org.processmining.plugins.queueminer.context;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.queueminer.context.TimeContext;

@Plugin(name = "Merge context info", returnLabels = { "Context model" }, returnTypes = { TimeContext.class }, parameterLabels = {
		"Context model", "TimeContext", "Parameters" }, userAccessible = true)
public class MergeContextPlugin {
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "L.P.J. de Smet", email = "l.p.j.d.smet@student.tue.nl")
	@PluginVariant(variantLabel = "Merge context info models", requiredParameterLabels = { 0,1})
	public TimeContext enrichWithContext(UIPluginContext context, TimeContext tcontext1, TimeContext tcontext2) {
		return TimeContext.simpleMerge(tcontext1,tcontext2);
	}
}
