package org.processmining.plugins.queueminer.context;

import java.io.InputStream;

import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.models.queueminer.context.ContextInfoParser;
import org.processmining.models.queueminer.context.TimeContext;

@Plugin(name = "Import Context model from XML file", parameterLabels = { "Filename" }, returnLabels = { "Context model" }, returnTypes = { TimeContext.class })
@UIImportPlugin(description = "Context model from XML file", extensions = { "xml" })
public class ReadTimeContextPlugin extends AbstractImportPlugin {

	/**
	 * Gets the file filter for this import plug-in. Description is "Context files",
	 * extension is "xml".
	 * 
	 * @return
	 */
	protected FileFilter getFileFilter() {
		return new FileNameExtensionFilter("Context model from XML file", "xml");
	}

	/**
	 * Imports the context model from the xml file.
	 */
	protected Object importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		TimeContext tc = ContextInfoParser.readTimeContext(input);
		if(tc.items.isEmpty()){
			throw new Exception("No valid input found");
		}
		return tc;
	}

}