package org.processmining.plugins.queueminer.logcontext;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.queueminer.context.ConcatenatedContext;
import org.processmining.models.queueminer.context.TimeContext;
import org.processmining.models.queueminer.logcontext.LogEnricher;

@Plugin(name = "Enrich log with context info", returnLabels = { "XES Log" }, returnTypes = { XLog.class }, parameterLabels = {
		"XES Log", "TimeContext", "Parameters" }, userAccessible = true)
public class LogEnrichPlugin {
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "L.P.J. de Smet", email = "l.p.j.d.smet@student.tue.nl")
	@PluginVariant(variantLabel = "Enrich log with context info", requiredParameterLabels = { 0,1})
	public XLog enrichWithContext(UIPluginContext context, XLog log, TimeContext tcontext) {
		ConcatenatedContext cc = tcontext.concatenateAll();
		
		return LogEnricher.enrichLog(cc, log);
	}
}
