package org.processmining.plugins.queueminer.logcontext;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.queueminer.context.TimeContext;
import org.processmining.models.queueminer.logcontext.LogWorkloadContextFinder;

@Plugin(name = "Extract workload information", returnLabels = { "Context model" }, returnTypes = { TimeContext.class }, parameterLabels = {
		"XES Log", "Parameters" }, userAccessible = true)
public class LogWorkLoadContextFinderPlugin {
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "L.P.J. de Smet", email = "l.p.j.d.smet@student.tue.nl")
	@PluginVariant(variantLabel = "Extract workload information", requiredParameterLabels = { 0})
	public TimeContext findWorkLoad(UIPluginContext context, XLog log) {
		return LogWorkloadContextFinder.findWorkLoadInformation(log);
	}
}
