package org.processmining.plugins.queueminer.matrixfinder;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.Progress;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.queueminer.matrixfinder.MatrixFinder;
import org.processmining.models.queueminer.matrixfinder.ResActMatrix;

@Plugin(name = "Resource activity matrix finder", returnLabels = { "ResActMatrix" }, returnTypes = { ResActMatrix.class }, parameterLabels = {
		"XES Log", "Parameters" }, userAccessible = false)
public class ResActMatrixPlugin {
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "L.P.J. de Smet", email = "l.p.j.d.smet@student.tue.nl")
	@PluginVariant(variantLabel = "Resource activity matrix finder", requiredParameterLabels = { 0})
	public ResActMatrix findCalendar(UIPluginContext context, XLog log) {
		Progress p = context.getProgress();
		p.setMinimum(0);
		p.setMaximum(log.size());
		p.setCaption("Scanning traces for resources and activities");
		return MatrixFinder.findMatrix(log,p);
	}
}
