package org.processmining.plugins.queueminer.patternvisualizer;

import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JPanel;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.models.queueminer.patternvisualizer.PLTButtons;
import org.processmining.models.queueminer.patternvisualizer.PrimeLogTree;
import org.processmining.models.queueminer.patternvisualizer.PrimeLogTreeView;
import org.processmining.models.queueminer.utils.TimeActivity;
import org.processmining.models.queueminer.utils.TimeActivityUtilities;
import org.processmining.models.queueminer.utils.TimeUtilities;

public class PrimeLogTreeViewerPlugin {
	@Plugin(name = "PrimeLogTree Viewer", returnLabels = { "Visualization of effect of splitting up logs" }, returnTypes = { JComponent.class }, parameterLabels = {"XES Log"}, userAccessible = false)
	@Visualizer
	public JComponent viewTree(PluginContext context, XLog log){
		ArrayList<TimeActivity> tlog = TimeActivityUtilities.findTimeActivities(log);
		long weekStart = TimeUtilities.findFirstWeekStart(tlog);
		PrimeLogTree plt = new PrimeLogTree(100,tlog,new int[]{2,3,5},weekStart);
		PrimeLogTreeView pltv = new PrimeLogTreeView(plt);
		JPanel total = new JPanel();
		total.setLayout(new BoxLayout(total,BoxLayout.LINE_AXIS));
		total.add(pltv);
		PLTButtons buttons = new PLTButtons(pltv);
		total.add(buttons.getButtonPanel());
		return total;
	}
}
