package org.processmining.plugins.queueminer.queueclusterer;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.Progress;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.queueminer.matrixfinder.ResActMatrix;
import org.processmining.models.queueminer.queueclusterer.ClusterFinder;
import org.processmining.models.queueminer.queueclusterer.QueueClustering;

@Plugin(name = "Queue clusterer", returnLabels = { "QueueClustering" }, returnTypes = { QueueClustering.class }, parameterLabels = {
		"XES Log", "ResActMatrix", "Parameters" }, userAccessible = false)
public class QueueClustererPlugin {
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "L.P.J. de Smet", email = "l.p.j.d.smet@student.tue.nl")
	@PluginVariant(variantLabel = "Queue clusterer", requiredParameterLabels = { 0,1})
	public QueueClustering findClustering(UIPluginContext context, XLog log, ResActMatrix ram) {
		Progress p = context.getProgress();
		p.setCaption("Clustering log into queue set");
		return ClusterFinder.findQueueClustering(log, ram,p);
	}
}
