package org.processmining.plugins.queueminer.queuepredictor;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

import org.processmining.contexts.uitopia.annotations.UIExportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.queueminer.queuepredictor.PredictionDataContainer;
import org.processmining.models.queueminer.queuepredictor.PredictionDataVisualizer;
import org.processmining.models.queueminer.utils.ArrivingEvent;
@Plugin(name = "Export Prediction Data (CSV)", returnLabels = {}, returnTypes = {}, parameterLabels = {
		"Context model", "File" }, userAccessible = true)
@UIExportPlugin(description = "CSV files", extension = "csv")
public class ExportPredictionDataPlugin {
	@PluginVariant(variantLabel = "Export Prediction Data (CSV)", requiredParameterLabels = { 0, 1 })
	public void export(PluginContext context, PredictionDataContainer pdc, File file) throws IOException {
		 PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(file)));
		 ArrayList<ArrivingEvent> aes = pdc.getPredictionData();
		 String nextLine;
		 for(int i = 0; i < aes.size(); i++){
			nextLine = "";
		 	nextLine += aes.get(i).getID()+",";
		 	nextLine += aes.get(i).eventType+",";
		 	nextLine += PredictionDataVisualizer.formatTime(aes.get(i).arrivalTime)+",";
		 	nextLine += aes.get(i).context+",";
		 	nextLine += PredictionDataVisualizer.formatTime(aes.get(i).getPredictedTime())+"\n";
		 	out.write(nextLine);
		}
		out.close();
	}
}
