package org.processmining.plugins.queueminer.startupremover;

import org.deckfour.uitopia.api.event.TaskListener.InteractionResult;
import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.dialogs.queueminer.startupremover.RemoverIntervalDialog;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.queueminer.startupremover.StartUpRemover;
import org.processmining.confs.queueminer.startupremover.StartUpRemoveConf;

@Plugin(name = "Start up period remover", returnLabels = { "XES Log" }, returnTypes = { XLog.class }, parameterLabels = {
		"XES Log", "Parameters" }, userAccessible = true)
public class StartUpRemoverPlugin {
	
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "L.P.J. de Smet", email = "l.p.j.d.smet@student.tue.nl")
	@PluginVariant(variantLabel = "Start up remover", requiredParameterLabels = { 0})
	public XLog removeStartUp(UIPluginContext context,XLog log){
		StartUpRemoveConf surc = new StartUpRemoveConf(0,Long.MAX_VALUE);
		//handle user input star/end
		RemoverIntervalDialog rid = new RemoverIntervalDialog(surc,log);
		
		InteractionResult result = context.showWizard("Start up remover config", true, true, rid);
		if (result == InteractionResult.FINISHED) {
	    	return StartUpRemover.removePeriod(log, surc.start, surc.end);
	    }
		//Something went terribly wrong (or it was just canceled!)
	    return null;
	}
}

